package de.htwk.s3

import android.content.Intent
import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import kotlinx.android.synthetic.main.activity_main.*

class MainActivity : AppCompatActivity() {

    val SAVED_PARCEL_KEY = "saved_parcel_key"

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        button.setOnClickListener {
            val intent = Intent(this,SecondActivity::class.java)
            val parameterObject = ParameterObject(editText.text.toString(),checkBox.isChecked,seekBar.progress)
            intent.putExtra(SecondActivity.PARAMETER_OBJECT_KEY,parameterObject)
            startActivity(intent)
        }
    }

    override fun onSaveInstanceState(outState: Bundle?) {
        super.onSaveInstanceState(outState)
        val parameterObject = ParameterObject(editText.text.toString(),checkBox.isChecked,seekBar.progress)
        outState?.putParcelable(SAVED_PARCEL_KEY,parameterObject)
    }

    override fun onRestoreInstanceState(savedInstanceState: Bundle?) {
        super.onRestoreInstanceState(savedInstanceState)
        savedInstanceState?.let {
            if (it.containsKey(SAVED_PARCEL_KEY)){

                val parameterObject: ParameterObject? = it.getParcelable(SAVED_PARCEL_KEY)
                Log.i("Parcel",parameterObject.toString())
                editText.setText(parameterObject?.string)
                checkBox.isChecked = parameterObject?.bool ?: false
                seekBar.progress = parameterObject?.int ?: 50
            }
        }
    }

}
