package de.htwk.s3

import android.os.Parcel
import android.os.Parcelable

data class ParameterObject(val string: String?, val bool: Boolean, val int: Int) : Parcelable{
    constructor(parcel: Parcel) : this(
        parcel.readString(),
        parcel.readByte() != 0.toByte(),
        parcel.readInt()
    ) {
    }

    override fun writeToParcel(parcel: Parcel, flags: Int) {
        parcel.writeString(string)
        parcel.writeByte(if (bool) 1 else 0)
        parcel.writeInt(int)
    }

    override fun describeContents(): Int {
        return 0
    }

    companion object CREATOR : Parcelable.Creator<ParameterObject> {
        override fun createFromParcel(parcel: Parcel): ParameterObject {
            return ParameterObject(parcel)
        }

        override fun newArray(size: Int): Array<ParameterObject?> {
            return arrayOfNulls(size)
        }
    }
}